Index: TvEngine3/TVLibrary/TVLibrary/Implementations/Helper/Providers/SkyItaly.cs
===================================================================
--- TvEngine3/TVLibrary/TVLibrary/Implementations/Helper/Providers/SkyItaly.cs	(revision 0)
+++ TvEngine3/TVLibrary/TVLibrary/Implementations/Helper/Providers/SkyItaly.cs	(revision 0)
@@ -0,0 +1,339 @@
+// Copyright (C) 2005-2010 Team MediaPortal
+// http://www.team-mediaportal.com
+// 
+// MediaPortal is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 2 of the License, or
+// (at your option) any later version.
+// 
+// MediaPortal is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+// GNU General Public License for more details.
+// 
+// You should have received a copy of the GNU General Public License
+// along with MediaPortal. If not, see <http://www.gnu.org/licenses/>.
+
+
+using System;
+using System.Collections.Generic;
+using TvLibrary.Interfaces;
+using TvLibrary.Interfaces.Analyzer;
+using TvLibrary.Channels;
+using TvDatabase;
+using DirectShowLib.BDA;
+
+namespace TvLibrary.Implementations.Helper.Providers
+{
+
+  /// <summary>
+  /// Helper class for provider specific functionality
+  /// </summary>
+  public class SkyItaly
+    : Provider
+  {
+    #region Fields
+
+    /// <summary>
+    /// Singleton instance
+    /// </summary>
+    private static readonly SkyItaly _instance = new SkyItaly();
+
+    private const uint INTERNAL_ID = 0x02;
+
+    private const int SKY_ITALY_DEFAULT_TRANSPONDER_FREQUENCY = 11881000;
+    private const string SKY_ITALY_DEFAULT_TRANSPONDER_POLARISATION = "Vertical";
+    private const int SKY_ITALY_DEFAULT_TRANSPONDER_SYMBOL_RATE = 27500;
+    private const string SKY_ITALY_DEFAULT_TRANSPONDER_INNER_FEC = "3/4";
+    private const int SKY_ITALY_DEFAULT_NETWORK_ID = 0xFBFF;
+
+    #endregion
+
+    #region Properties
+
+    /// <summary>
+    /// Gets the internal id for Sky Italy
+    /// </summary>
+    public uint InternalId
+    {
+      get
+      {
+        return INTERNAL_ID;
+      }
+    }
+
+    /// <summary>
+    /// Gets the instance
+    /// </summary>
+    public static SkyItaly Instance
+    {
+      get
+      {
+        return _instance;
+      }
+    }
+
+    /// <summary>
+    /// Gets if the EPG should be grabbed for Sky Italy
+    /// </summary>
+    public bool EPGGrabbingEnabled
+    {
+      get
+      {
+        return GetSetting<bool>("SkyItalyGrabEPG", false);
+      }
+      set
+      {
+        SetSetting("SkyItalyGrabEPG", value);
+      }
+    }
+
+    /// <summary>
+    /// Gets/Sets the last epg grab time
+    /// </summary>
+    public DateTime LastEPGGrabTime
+    {
+      get
+      {
+        DateTime lastGrabTime = DateTime.MinValue;
+
+        DateTime.TryParse(GetSetting<string>("SkyItalyLastEPGGrabTime", DateTime.MinValue.ToString()), out lastGrabTime);
+
+        return lastGrabTime;
+      }
+      set
+      {
+        SetSetting("SkyItalyLastEPGGrabTime", value.ToString());
+      }
+    }
+
+    /// <summary>
+    /// Gets/Sets the default transponder frequency
+    /// </summary>
+    public int DefaultTransponderFrequency
+    {
+      get
+      {
+        return GetSetting<int>("SkyItalyDefaultTransponderFrequency", SKY_ITALY_DEFAULT_TRANSPONDER_FREQUENCY);
+      }
+      set
+      {
+        SetSetting("SkyItalyDefaultTransponderFrequency", value);
+      }
+    }
+
+    /// <summary>
+    /// Gets/Sets the default transponder polarisation
+    /// </summary>
+    public string DefaultTransponderPolarisationString
+    {
+      get
+      {
+        return GetSetting<string>("SkyItalyDefaultTransponderPolarisation", SKY_ITALY_DEFAULT_TRANSPONDER_POLARISATION);
+      }
+      set
+      {
+        SetSetting("SkyItalyDefaultTransponderPolarisation", value);
+      }
+    }
+
+    public Polarisation DefaultTransponderPolarisation
+    {
+      get
+      {
+        switch (DefaultTransponderPolarisationString)
+        {
+          case "Horizontal":
+            return Polarisation.LinearH;
+          case "Vertical":
+            return Polarisation.LinearV;
+          case "Circular Left":
+            return Polarisation.CircularL;
+          case "Circular Right":
+            return Polarisation.CircularR;
+        }
+
+        return Polarisation.LinearV;
+      }
+      set
+      {
+        switch (value)
+        {
+          case Polarisation.LinearH:
+            DefaultTransponderPolarisationString = "Horizontal";
+            break;
+          case Polarisation.LinearV:
+            DefaultTransponderPolarisationString = "Vertical";
+            break;
+          case Polarisation.CircularL:
+            DefaultTransponderPolarisationString = "Circular Left";
+            break;
+          case Polarisation.CircularR:
+            DefaultTransponderPolarisationString = "Circular Right";
+            break;
+
+          default:
+            DefaultTransponderPolarisationString = SKY_ITALY_DEFAULT_TRANSPONDER_POLARISATION;
+            break;
+        }
+      }
+    }
+
+    /// <summary>
+    /// Gets/Sets the default transponder symbol rate
+    /// </summary>
+    public int DefaultTransponderSymbolRate
+    {
+      get
+      {
+        return GetSetting<int>("SkyItalyDefaultTransponderSymbolRate", SKY_ITALY_DEFAULT_TRANSPONDER_SYMBOL_RATE);
+      }
+      set
+      {
+        SetSetting("SkyItalyDefaultTransponderSymbolRate", value);
+      }
+    }
+
+    /// <summary>
+    /// Gets/Sets the default transponder inner FEC
+    /// </summary>
+    public string DefaultTransponderInnerFECString
+    {
+      get
+      {
+        return GetSetting<string>("SkyItalyDefaultTransponderInnerFEC", SKY_ITALY_DEFAULT_TRANSPONDER_INNER_FEC);
+      }
+      set
+      {
+        SetSetting("SkyItalyDefaultTransponderInnerFEC", value);
+      }
+    }
+
+    /// <summary>
+    /// Gets the default transponder inner FEC
+    /// </summary>
+    public BinaryConvolutionCodeRate DefaultTransponderInnerFEC
+    {
+      get
+      {
+        switch (DefaultTransponderInnerFECString)
+        {
+          case "1/2":
+            return BinaryConvolutionCodeRate.Rate1_2;
+          case "1/3":
+            return BinaryConvolutionCodeRate.Rate1_3;
+          case "1/4":
+            return BinaryConvolutionCodeRate.Rate1_4;
+          case "2/3":
+            return BinaryConvolutionCodeRate.Rate2_3;
+          case "2/5":
+            return BinaryConvolutionCodeRate.Rate2_5;
+          case "3/4":
+            return BinaryConvolutionCodeRate.Rate3_4;
+          case "3/5":
+            return BinaryConvolutionCodeRate.Rate3_5;
+          case "4/5":
+            return BinaryConvolutionCodeRate.Rate4_5;
+          case "5/11":
+            return BinaryConvolutionCodeRate.Rate5_11;
+          case "5/6":
+            return BinaryConvolutionCodeRate.Rate5_6;
+          case "7/8":
+            return BinaryConvolutionCodeRate.Rate7_8;
+          case "8/9":
+            return BinaryConvolutionCodeRate.Rate8_9;
+          case "9/10":
+            return BinaryConvolutionCodeRate.Rate9_10;
+        }
+
+        return BinaryConvolutionCodeRate.Rate2_3;
+      }
+      set
+      {
+        switch (value)
+        {
+          case BinaryConvolutionCodeRate.Rate1_2:
+            DefaultTransponderInnerFECString = "1/2";
+            break;
+          case BinaryConvolutionCodeRate.Rate1_3:
+            DefaultTransponderInnerFECString = "1/3";
+            break;
+          case BinaryConvolutionCodeRate.Rate1_4:
+            DefaultTransponderInnerFECString = "1/4";
+            break;
+          case BinaryConvolutionCodeRate.Rate2_3:
+            DefaultTransponderInnerFECString = "2/3";
+            break;
+          case BinaryConvolutionCodeRate.Rate2_5:
+            DefaultTransponderInnerFECString = "2/5";
+            break;
+          case BinaryConvolutionCodeRate.Rate3_4:
+            DefaultTransponderInnerFECString = "3/4";
+            break;
+          case BinaryConvolutionCodeRate.Rate3_5:
+            DefaultTransponderInnerFECString = "3/5";
+            break;
+          case BinaryConvolutionCodeRate.Rate4_5:
+            DefaultTransponderInnerFECString = "4/5";
+            break;
+          case BinaryConvolutionCodeRate.Rate5_11:
+            DefaultTransponderInnerFECString = "5/11";
+            break;
+          case BinaryConvolutionCodeRate.Rate5_6:
+            DefaultTransponderInnerFECString = "5/6";
+            break;
+          case BinaryConvolutionCodeRate.Rate6_7:
+            DefaultTransponderInnerFECString = "6/7";
+            break;
+          case BinaryConvolutionCodeRate.Rate7_8:
+            DefaultTransponderInnerFECString = "7/8";
+            break;
+          case BinaryConvolutionCodeRate.Rate8_9:
+            DefaultTransponderInnerFECString = "8/9";
+            break;
+          case BinaryConvolutionCodeRate.Rate9_10:
+            DefaultTransponderInnerFECString = "9/10";
+            break;
+
+          default:
+            DefaultTransponderInnerFECString = "2/3";
+            break;
+        }
+      }
+    }
+
+    /// <summary>
+    /// Gets/Sets the default transponder symbol rate
+    /// </summary>
+    public int NetworkId
+    {
+      get
+      {
+        return GetSetting<int>("SkyItalyNetworkId", SKY_ITALY_DEFAULT_NETWORK_ID);
+      }
+      set
+      {
+        SetSetting("SkyItalyNetworkId", value);
+      }
+    }
+
+    #endregion
+
+    #region Methods
+
+    /// <summary>
+    /// Resets the default transponder parameters
+    /// </summary>
+    public void ResetDefaultTransponderParameters()
+    {
+      DefaultTransponderFrequency = SKY_ITALY_DEFAULT_TRANSPONDER_FREQUENCY;
+      DefaultTransponderPolarisationString = SKY_ITALY_DEFAULT_TRANSPONDER_POLARISATION;
+      DefaultTransponderSymbolRate = SKY_ITALY_DEFAULT_TRANSPONDER_SYMBOL_RATE;
+      DefaultTransponderInnerFECString = SKY_ITALY_DEFAULT_TRANSPONDER_INNER_FEC;
+      NetworkId = SKY_ITALY_DEFAULT_NETWORK_ID;
+    }
+
+    #endregion
+
+  }
+}
Index: TvEngine3/TVLibrary/TVLibrary/Implementations/Helper/Providers/SkyUK.cs
===================================================================
--- TvEngine3/TVLibrary/TVLibrary/Implementations/Helper/Providers/SkyUK.cs	(revision 0)
+++ TvEngine3/TVLibrary/TVLibrary/Implementations/Helper/Providers/SkyUK.cs	(revision 0)
@@ -0,0 +1,339 @@
+// Copyright (C) 2005-2010 Team MediaPortal
+// http://www.team-mediaportal.com
+// 
+// MediaPortal is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 2 of the License, or
+// (at your option) any later version.
+// 
+// MediaPortal is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+// GNU General Public License for more details.
+// 
+// You should have received a copy of the GNU General Public License
+// along with MediaPortal. If not, see <http://www.gnu.org/licenses/>.
+
+
+using System;
+using System.Collections.Generic;
+using TvLibrary.Interfaces;
+using TvLibrary.Interfaces.Analyzer;
+using TvLibrary.Channels;
+using TvDatabase;
+using DirectShowLib.BDA;
+
+namespace TvLibrary.Implementations.Helper.Providers
+{
+
+  /// <summary>
+  /// Helper class for provider specific functionality
+  /// </summary>
+  public class SkyUK
+    : Provider
+  {
+    #region Fields
+
+    /// <summary>
+    /// Singleton instance
+    /// </summary>
+    private static readonly SkyUK _instance = new SkyUK();
+
+    private const uint INTERNAL_ID = 0x01;
+
+    private const int SKY_UK_DEFAULT_TRANSPONDER_FREQUENCY = 11778000;
+    private const string SKY_UK_DEFAULT_TRANSPONDER_POLARISATION = "Vertical";
+    private const int SKY_UK_DEFAULT_TRANSPONDER_SYMBOL_RATE = 27500;
+    private const string SKY_UK_DEFAULT_TRANSPONDER_INNER_FEC = "2/3";
+    private const int SKY_UK_DEFAULT_NETWORK_ID = 0x2;
+
+    #endregion
+
+    #region Properties
+
+    /// <summary>
+    /// Gets the internal id for Sky UK
+    /// </summary>
+    public uint InternalId
+    {
+      get
+      {
+        return INTERNAL_ID;
+      }
+    }
+
+    /// <summary>
+    /// Gets the instance
+    /// </summary>
+    public static SkyUK Instance
+    {
+      get
+      {
+        return _instance;
+      }
+    }
+
+    /// <summary>
+    /// Gets/Sets if the EPG should be grabbed for Sky UK
+    /// </summary>
+    public bool EPGGrabbingEnabled
+    {
+      get
+      {
+        return GetSetting<bool>("SkyUKGrabEPG", false);
+      }
+      set
+      {
+        SetSetting("SkyUKGrabEPG", value);
+      }
+    }
+
+    /// <summary>
+    /// Gets/Sets the last epg grab time
+    /// </summary>
+    public DateTime LastEPGGrabTime
+    {
+      get
+      {
+        DateTime lastGrabTime = DateTime.MinValue;
+
+        DateTime.TryParse(GetSetting<string>("SkyUKLastEPGGrabTime", DateTime.MinValue.ToString()), out lastGrabTime);
+
+        return lastGrabTime;
+      }
+      set
+      {
+        SetSetting("SkyUKLastEPGGrabTime", value.ToString());
+      }
+    }
+
+    /// <summary>
+    /// Gets/Sets the default transponder frequency
+    /// </summary>
+    public int DefaultTransponderFrequency
+    {
+      get
+      {
+        return GetSetting<int>("SkyUKDefaultTransponderFrequency", SKY_UK_DEFAULT_TRANSPONDER_FREQUENCY);
+      }
+      set
+      {
+        SetSetting("SkyUKDefaultTransponderFrequency", value);
+      }
+    }
+
+    /// <summary>
+    /// Gets/Sets the default transponder polarisation
+    /// </summary>
+    public string DefaultTransponderPolarisationString
+    {
+      get
+      {
+        return GetSetting<string>("SkyUKDefaultTransponderPolarisation", SKY_UK_DEFAULT_TRANSPONDER_POLARISATION);
+      }
+      set
+      {
+        SetSetting("SkyUKDefaultTransponderPolarisation", value);
+      }
+    }
+
+    public Polarisation DefaultTransponderPolarisation
+    {
+      get
+      {
+        switch (DefaultTransponderPolarisationString)
+        {
+          case "Horizontal":
+            return Polarisation.LinearH;
+          case "Vertical":
+            return Polarisation.LinearV;
+          case "Circular Left":
+            return Polarisation.CircularL;
+          case "Circular Right":
+            return Polarisation.CircularR;
+        }
+
+        return Polarisation.LinearV;
+      }
+      set
+      {
+        switch (value)
+        {
+          case Polarisation.LinearH:
+            DefaultTransponderPolarisationString = "Horizontal";
+            break;
+          case Polarisation.LinearV:
+            DefaultTransponderPolarisationString = "Vertical";
+            break;
+          case Polarisation.CircularL:
+            DefaultTransponderPolarisationString = "Circular Left";
+            break;
+          case Polarisation.CircularR:
+            DefaultTransponderPolarisationString = "Circular Right";
+            break;
+
+          default:
+            DefaultTransponderPolarisationString = SKY_UK_DEFAULT_TRANSPONDER_POLARISATION;
+            break;
+        }
+      }
+    }
+
+    /// <summary>
+    /// Gets/Sets the default transponder symbol rate
+    /// </summary>
+    public int DefaultTransponderSymbolRate
+    {
+      get
+      {
+        return GetSetting<int>("SkyUKDefaultTransponderSymbolRate", SKY_UK_DEFAULT_TRANSPONDER_SYMBOL_RATE);
+      }
+      set
+      {
+        SetSetting("SkyUKDefaultTransponderSymbolRate", value);
+      }
+    }
+
+    /// <summary>
+    /// Gets/Sets the default transponder inner FEC
+    /// </summary>
+    public string DefaultTransponderInnerFECString
+    {
+      get
+      {
+        return GetSetting<string>("SkyUKDefaultTransponderInnerFEC", SKY_UK_DEFAULT_TRANSPONDER_INNER_FEC);
+      }
+      set
+      {
+        SetSetting("SkyUKDefaultTransponderInnerFEC", value);
+      }
+    }
+
+    /// <summary>
+    /// Gets the default transponder inner FEC
+    /// </summary>
+    public BinaryConvolutionCodeRate DefaultTransponderInnerFEC
+    {
+      get
+      {
+        switch (DefaultTransponderInnerFECString)
+        {
+          case "1/2":
+            return BinaryConvolutionCodeRate.Rate1_2;
+          case "1/3":
+            return BinaryConvolutionCodeRate.Rate1_3;
+          case "1/4":
+            return BinaryConvolutionCodeRate.Rate1_4;
+          case "2/3":
+            return BinaryConvolutionCodeRate.Rate2_3;
+          case "2/5":
+            return BinaryConvolutionCodeRate.Rate2_5;
+          case "3/4":
+            return BinaryConvolutionCodeRate.Rate3_4;
+          case "3/5":
+            return BinaryConvolutionCodeRate.Rate3_5;
+          case "4/5":
+            return BinaryConvolutionCodeRate.Rate4_5;
+          case "5/11":
+            return BinaryConvolutionCodeRate.Rate5_11;
+          case "5/6":
+            return BinaryConvolutionCodeRate.Rate5_6;
+          case "7/8":
+            return BinaryConvolutionCodeRate.Rate7_8;
+          case "8/9":
+            return BinaryConvolutionCodeRate.Rate8_9;
+          case "9/10":
+            return BinaryConvolutionCodeRate.Rate9_10;
+        }
+
+        return BinaryConvolutionCodeRate.Rate2_3;
+      }
+      set
+      {
+        switch (value)
+        {
+          case BinaryConvolutionCodeRate.Rate1_2:
+            DefaultTransponderInnerFECString = "1/2";
+            break;
+          case BinaryConvolutionCodeRate.Rate1_3:
+            DefaultTransponderInnerFECString = "1/3";
+            break;
+          case BinaryConvolutionCodeRate.Rate1_4:
+            DefaultTransponderInnerFECString = "1/4";
+            break;
+          case BinaryConvolutionCodeRate.Rate2_3:
+            DefaultTransponderInnerFECString = "2/3";
+            break;
+          case BinaryConvolutionCodeRate.Rate2_5:
+            DefaultTransponderInnerFECString = "2/5";
+            break;
+          case BinaryConvolutionCodeRate.Rate3_4:
+            DefaultTransponderInnerFECString = "3/4";
+            break;
+          case BinaryConvolutionCodeRate.Rate3_5:
+            DefaultTransponderInnerFECString = "3/5";
+            break;
+          case BinaryConvolutionCodeRate.Rate4_5:
+            DefaultTransponderInnerFECString = "4/5";
+            break;
+          case BinaryConvolutionCodeRate.Rate5_11:
+            DefaultTransponderInnerFECString = "5/11";
+            break;
+          case BinaryConvolutionCodeRate.Rate5_6:
+            DefaultTransponderInnerFECString = "5/6";
+            break;
+          case BinaryConvolutionCodeRate.Rate6_7:
+            DefaultTransponderInnerFECString = "6/7";
+            break;
+          case BinaryConvolutionCodeRate.Rate7_8:
+            DefaultTransponderInnerFECString = "7/8";
+            break;
+          case BinaryConvolutionCodeRate.Rate8_9:
+            DefaultTransponderInnerFECString = "8/9";
+            break;
+          case BinaryConvolutionCodeRate.Rate9_10:
+            DefaultTransponderInnerFECString = "9/10";
+            break;
+
+          default:
+            DefaultTransponderInnerFECString = "2/3";
+            break;
+        }
+      }
+    }
+
+    /// <summary>
+    /// Gets/Sets the default transponder symbol rate
+    /// </summary>
+    public int NetworkId
+    {
+      get
+      {
+        return GetSetting<int>("SkyUKNetworkId", SKY_UK_DEFAULT_NETWORK_ID);
+      }
+      set
+      {
+        SetSetting("SkyUKNetworkId", value);
+      }
+    }
+
+    #endregion
+
+    #region Methods
+
+    /// <summary>
+    /// Resets the default transponder parameters
+    /// </summary>
+    public void ResetDefaultTransponderParameters()
+    {
+      DefaultTransponderFrequency = SKY_UK_DEFAULT_TRANSPONDER_FREQUENCY;
+      DefaultTransponderPolarisationString = SKY_UK_DEFAULT_TRANSPONDER_POLARISATION;
+      DefaultTransponderSymbolRate = SKY_UK_DEFAULT_TRANSPONDER_SYMBOL_RATE;
+      DefaultTransponderInnerFECString = SKY_UK_DEFAULT_TRANSPONDER_INNER_FEC;
+      NetworkId = SKY_UK_DEFAULT_NETWORK_ID;
+    }
+
+    #endregion
+
+  }
+}
Index: TvEngine3/TVLibrary/TVLibrary/Interfaces/Analyzer/ITsEpgScanner.cs
===================================================================
--- TvEngine3/TVLibrary/TVLibrary/Interfaces/Analyzer/ITsEpgScanner.cs	(revision 27484)
+++ TvEngine3/TVLibrary/TVLibrary/Interfaces/Analyzer/ITsEpgScanner.cs	(working copy)
@@ -186,6 +186,77 @@
     int GetMHWTheme(uint themeId, out IntPtr theme);
 
     /// <summary>
+    /// Starts the sky epg grabber
+    /// Country:
+    /// 1 = UK
+    /// 2 = Italy
+    /// 3 = Australia (Not yet implemented)
+    /// </summary>
+    /// <returns></returns>
+    [PreserveSig]
+    int ActivateSkyEpgGrabber(uint country);
+
+    /// <summary>
+    /// Gets if the Sky epg is active
+    /// </summary>
+    /// <param name="active"></param>
+    /// <returns></returns>
+    [PreserveSig]
+    int IsSkyEpgGrabberActive(ref byte active);
+
+    /// <summary>
+    /// Gets if the Sky epg is ready to be retrieved from tswriter
+    /// </summary>
+    /// <param name="ready"></param>
+    /// <returns></returns>
+    [PreserveSig]
+    int IsSkyEpgReady(ref byte ready);
+
+    /// <summary>
+    /// Gets if the Sky epg grabbing was aborted
+    /// </summary>
+    /// <param name="aborted"></param>
+    /// <returns></returns>
+    [PreserveSig]
+    int HasSkyEpgAborted(ref byte aborted);
+
+    /// <summary>
+    /// Resets the epg retrieval iterators
+    /// </summary>
+    /// <returns></returns>
+    [PreserveSig]
+    int ResetSkyEpgRetrieval();
+
+    /// <summary>
+    /// Gets the next Sky epg channel
+    /// </summary>
+    /// <param name="atEndChannel"></param>
+    /// <param name="channelId"></param>
+    /// <param name="networkId"></param>
+    /// <param name="transportId"></param>
+    /// <param name="serviceId"></param>
+    /// <returns></returns>
+    [PreserveSig]
+    int GetNextSkyEpgChannel(ref byte atEndChannel, ref ushort channelId, ref ushort networkId, ref ushort transportId, ref ushort serviceId);
+
+    /// <summary>
+    /// Gets the next Sky channel epg event
+    /// </summary>
+    /// <param name="atEndChannelEvent"></param>
+    /// <param name="eventId"></param>
+    /// <param name="mjdStart"></param>
+    /// <param name="startTime"></param>
+    /// <param name="duration"></param>
+    /// <param name="title"></param>
+    /// <param name="summary"></param>
+    /// <param name="theme"></param>
+    /// <param name="seriesId"></param>
+    /// <param name="seriesTermination"></param>
+    /// <returns></returns>
+    [PreserveSig]
+    int GetNextSkyEpgChannelEvent(ref byte atEndChannelEvent, ref ushort eventId, ref ushort mjdStart, ref uint startTime, ref uint duration, out IntPtr title, out IntPtr summary, out IntPtr theme, ref ushort seriesId, ref byte seriesTermination);
+
+    /// <summary>
     /// Resets this MHW grabber.
     /// </summary>
     /// <returns></returns>
Index: TvEngine3/TVLibrary/TVLibrary/TVLibrary.csproj
===================================================================
--- TvEngine3/TVLibrary/TVLibrary/TVLibrary.csproj	(revision 27484)
+++ TvEngine3/TVLibrary/TVLibrary/TVLibrary.csproj	(working copy)
@@ -2,7 +2,7 @@
   <PropertyGroup>
     <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
     <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
-    <ProductVersion>9.0.30729</ProductVersion>
+    <ProductVersion>9.0.21022</ProductVersion>
     <SchemaVersion>2.0</SchemaVersion>
     <ProjectGuid>{59C2EBC8-0FEA-4B2E-B5D1-476347332331}</ProjectGuid>
     <OutputType>Library</OutputType>
@@ -152,6 +152,9 @@
     <Compile Include="Implementations\Helper\FilterGraphTools.cs" />
     <Compile Include="Implementations\Helper\GraphState.cs" />
     <Compile Include="Implementations\Helper\HResult.cs" />
+    <Compile Include="Implementations\Helper\Providers\SkyItaly.cs" />
+    <Compile Include="Implementations\Helper\Providers\Provider.cs" />
+    <Compile Include="Implementations\Helper\Providers\SkyUK.cs" />
     <Compile Include="Implementations\Helper\Release.cs" />
     <Compile Include="Implementations\Helper\SidHelper.cs" />
     <Compile Include="Implementations\Hybrid\HybridCardGroup.cs" />
